/*
 * ProfPhreakApplet.java
 *
 * Copyright(c) 2001, Particle Corp.
 */

/*

Copyright (C) 1996-2001 Particle Corporation.
Alex S. (Particle)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

import java.applet.Applet;
import java.awt.TextArea;
import java.awt.TextField;
import java.awt.Button;
import java.awt.Panel;
import java.awt.BorderLayout;
import java.awt.Font;
import java.awt.Event;
import java.io.InputStream;
import java.io.PrintStream;
import java.io.IOException;
import java.net.URL;
import java.net.URLConnection;

/**
 * simple Applet client for the Prof.Phreak web service
 *
 * Note, this code is JDK 1.0 (deprecated) for a reason!
 * (it is designed to work with ANY browser)
 *
 * @author Alex S.
 * @version 0.0.1
 */
public class ProfPhreakApplet extends Applet {

    // default web service URL
    private static String SERVICE_URL = "http://www.theparticle.com/profphreak/webservice.cgi";

    private TextArea conversation;
    private TextField inputField;
    private Button sendButton;

    // general purpose buffer
    byte[] buffer = new byte[1024];

    public void init(){
        setLayout(new BorderLayout());
        conversation = new TextArea();
        conversation.setFont(new Font("Courier",Font.PLAIN,12));
        conversation.setEditable(false);
        sendButton = new Button("Send");
        inputField = new TextField();
        inputField.setFont(new Font("Courier",Font.PLAIN,12));
        Panel panel = new Panel();
        panel.setLayout(new BorderLayout());
        panel.add("Center",inputField);
        panel.add("East",sendButton);
        add("Center",conversation);
        add("South",panel);
        String v = getParameter("service_url");
        if(v != null)
            SERVICE_URL = v;
        show();

        // start of the conversation so that people don't feel lost.
        conversation.appendText("Prof.Phreak: Hi. What's up?\n");

        inputField.requestFocus();
    }

    /**
     * goes after the web service and gets a response.
     */
    public synchronized String getResponse(String input){
        String response;
        try{
            URL u = new URL(SERVICE_URL);

            // make connection
            URLConnection con = u.openConnection();
            con.setDoInput(true);
            con.setDoOutput(true);
            con.setUseCaches(false);
            con.setRequestProperty("Content-type","text/xml; charset=\"utf-8\"");
            con.setAllowUserInteraction( false );

            // send request (SOAP envelope in a POST request)
            PrintStream ps = new PrintStream(con.getOutputStream());
            ps.println("<env:Envelope xmlns:env=\"http://www.w3.org/2001/06/soap-envelope\">");
            ps.println(" <env:Body>");
            ps.println("  <ProfPhreakInput>"+input+"</ProfPhreakInput>");
            ps.println(" </env:Body>");
            ps.println("</env:Envelope>");
            ps.close();

            // get response (SOAP envelope) [read in buffer.length chunks]
            StringBuffer sb = new StringBuffer();
            InputStream is = con.getInputStream();
            int len = is.read(buffer);
            while(len != -1){
                sb.append(new String(buffer,0,0,len));
                len = is.read(buffer);
            }
            response = sb.toString();
        }catch(IOException e){
            return e.toString()+ ": "+SERVICE_URL;
        }

        // parse out the exact response we need
        int start = response.indexOf("<ProfPhreakOutput>");
        if(start > 0)
            start += "<ProfPhreakOutput>".length();
        int end = response.indexOf("</ProfPhreakOutput>");
        if(start < end && start >= 0 && end >= 0)
            return response.substring(start,end);
        return "WebService Error: Invalid SOAP Envelope.";
    }

    /**
     * handle button press event, and "enter" press event.
     */
    public boolean handleEvent(Event evt) {
        if(((evt.id == Event.KEY_PRESS || evt.id == Event.KEY_ACTION ) && evt.key == '\n') ||
           (evt.id == Event.ACTION_EVENT && evt.target == sendButton)) {
            conversation.appendText("You: "+inputField.getText()+"\n");
            conversation.appendText("Prof.Phreak: ");
            String response = getResponse(inputField.getText());
            for(int i=0;i<response.length();i++){
                conversation.appendText(""+response.charAt(i));
                try{
                    // simulate real human typing.
                    Thread.sleep((int)(100*Math.random()));
                }catch(InterruptedException e){
                    // do nothing.
                }
            }
            conversation.appendText("\n");
            inputField.setText("");
            return true;
        }
        return false;
    }
}

