/*
 * WebServiceClient.java
 *
 * Copyright(c) 2001, Particle Corp.
 */

/*

Copyright (C) 1996-2001 Particle Corporation.
Alex S. (Particle)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/

import java.io.*;
import java.net.*;

/**
 * simple client for the Prof.Phreak web service
 *
 * @author Alex S.
 * @version 0.0.1
 */
public class WebServiceClient {

    // web service URL (TODO: move this to a properties file)
    public static String SERVICE_URL = "http://www.theparticle.com/profphreak/webservice.cgi";

    /**
     * goes after the web service and gets a response.
     */
    public static String getResponse(String input) throws IOException {

        URL u = new URL(SERVICE_URL);

        // make connection
        URLConnection con = u.openConnection();
        con.setDoInput(true);
        con.setDoOutput(true);
        con.setUseCaches(false);
        con.setRequestProperty("Content-type","text/xml; charset=\"utf-8\"");
        con.setAllowUserInteraction( false );

        // send request (SOAP envelope in a POST request)
        PrintStream ps = new PrintStream(con.getOutputStream());
        ps.println("<env:Envelope xmlns:env=\"http://www.w3.org/2001/06/soap-envelope\">");
        ps.println(" <env:Body>");
        ps.println("  <ProfPhreakInput>"+input+"</ProfPhreakInput>");
        ps.println(" </env:Body>");
        ps.println("</env:Envelope>");
        ps.close();

        // get response (SOAP envelope)
        StringBuffer sb = new StringBuffer();
        BufferedReader r = new BufferedReader(new InputStreamReader(con.getInputStream()));
        char[] buffer = new char[1024];
        int len = r.read(buffer);
        while(len != -1){
            sb.append(buffer,0,len);
            len = r.read(buffer);
        }
        String response = sb.toString();

        // parse out the exact response we need
        int start = response.indexOf("<ProfPhreakOutput>");
        if(start > 0)
            start += "<ProfPhreakOutput>".length();
        int end = response.indexOf("</ProfPhreakOutput>");
        if(start < end && start >= 0 && end >= 0)
            return response.substring(start,end);
        return null;
    }

    /**
     * main to start the whole thing
     */
    public static void main(String[] args) throws IOException {

        // first parameter is the SERVICE_URL
        if(args.length > 0)
            SERVICE_URL = args[0];

        System.out.println("SERVICE_URL: "+SERVICE_URL);

        // loop reading input and displaying result.
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        System.out.print("> ");
        String line = br.readLine();
        while(line != null){
            line = line.trim();
            System.out.println(getResponse(line));
            System.out.print("> ");
            line = br.readLine();
        }
    }
}

